package cz.muni.fi.pb162.test2;

import junit.framework.TestCase;

/**
 *
 * @author petr
 */
public class LocomotiveTest extends TestCase {
    
    public LocomotiveTest(String testName) {
        super(testName);
    }
    
    public void testElectricMotorGetPower() {
        ElectricMotor motor = new ElectricMotor("mx",1600.0);
        assertEquals(1600.0,motor.getPower());
        motor = new ElectricMotor("mx",8000.0);
        assertEquals(8000.0,motor.getPower());
    }

    public void testElectricMotorToString() {
        ElectricMotor motor = new ElectricMotor("mx",1600.0);
        assertEquals("ElectricMotor(type = mx, power = 1.6 kW)",motor.toString());
        motor = new ElectricMotor("aaa",80000.0);
        assertEquals("ElectricMotor(type = aaa, power = 80.0 kW)",motor.toString());
    }

    public void testElectricLocomotiveGetPower() {
        ElectricMotor motor1 = new ElectricMotor("mx1",1600.0);
        ElectricMotor motor2 = new ElectricMotor("mx2",3200.0);
        ElectricMotor motor3 = new ElectricMotor("mx3",6400.0);
        ElectricMotor motor4 = new ElectricMotor("mx4",12800.0);
        Locomotive locomotive = new ElectricLocomotive("lx",motor1,motor2,motor3,motor4);
        assertEquals(24000.0,locomotive.getPower());
    }

    public void testElectricLocomotiveToString() {
        ElectricMotor motor1 = new ElectricMotor("mx1",1600.0);
        ElectricMotor motor2 = new ElectricMotor("mx2",3200.0);
        ElectricMotor motor3 = new ElectricMotor("mx3",6400.0);
        ElectricMotor motor4 = new ElectricMotor("mx4",12800.0);
        Locomotive locomotive = new ElectricLocomotive("lx",motor1,motor2,motor3,motor4);
        String expected = "Locomotive (type = lx, power = 24.0 kW) " + 
        "[ElectricMotor(type = mx1, power = 1.6 kW), " +
        "ElectricMotor(type = mx2, power = 3.2 kW), " +
        "ElectricMotor(type = mx3, power = 6.4 kW), " +
        "ElectricMotor(type = mx4, power = 12.8 kW)]";
        assertEquals(expected,locomotive.toString());
    }

    public void testDieselLocomotiveGetTraction() {
        Locomotive locomotive = new DieselLocomotive("mx",1600.0);
        assertEquals("diesel",locomotive.getTraction());        
    }

    public void testElectricLocomotiveGetTraction() {
        ElectricMotor motor1 = new ElectricMotor("mx1",1600.0);
        ElectricMotor motor2 = new ElectricMotor("mx2",3200.0);
        ElectricMotor motor3 = new ElectricMotor("mx3",6400.0);
        ElectricMotor motor4 = new ElectricMotor("mx4",12800.0);
        Locomotive locomotive = new ElectricLocomotive("lx",motor1,motor2,motor3,motor4);
        assertEquals("electric",locomotive.getTraction());        
    }
    
    public void testDieselLocomotiveGetPower() {
        Locomotive locomotive = new DieselLocomotive("mx",1600.0);
        assertEquals(1600.0,locomotive.getPower());
        locomotive = new DieselLocomotive("mx",8000.0);
        assertEquals(8000.0,locomotive.getPower());
    }

    public void testDieselLocomotiveToString() {
        Locomotive locomotive = new DieselLocomotive("mx",1600.0);
        assertEquals("DieselLocomotive(type = mx, power = 1.6 kW)",locomotive.toString());
        locomotive = new DieselLocomotive("aaa",80000.0);
        assertEquals("DieselLocomotive(type = aaa, power = 80.0 kW)",locomotive.toString());
    }


    public void testClassHierarchy(int number) {
        assertEquals(AbstractEngine.class,DieselLocomotive.class.getSuperclass());
        assertEquals(AbstractEngine.class,ElectricMotor.class.getSuperclass());
        assertFalse(AbstractEngine.class.isAssignableFrom(ElectricLocomotive.class));
        assertFalse(ElectricLocomotive.class.isAssignableFrom(AbstractEngine.class));
        assertFalse(ElectricMotor.class.isAssignableFrom(DieselLocomotive.class));
        assertFalse(DieselLocomotive.class.isAssignableFrom(ElectricMotor.class));
        assertTrue(Engine.class.isAssignableFrom(Locomotive.class));
        assertTrue(Engine.class.isAssignableFrom(AbstractEngine.class));
        assertTrue(Engine.class.isAssignableFrom(ElectricLocomotive.class));
        assertTrue(Engine.class.isAssignableFrom(DieselLocomotive.class));
        assertTrue(Engine.class.isAssignableFrom(ElectricMotor.class));
        assertTrue(Locomotive.class.isAssignableFrom(ElectricLocomotive.class));
        assertTrue(Locomotive.class.isAssignableFrom(DieselLocomotive.class));
    }

}
